#ifndef INC_GTMANAGER_H
#define INC_GTMANAGER_H

#include "gtwidget.h"

/************************************************************************\
*
* GtManager class header.
*
* $Ident: This file is part of the 'Gt-library' 1.0.0 $
* $Copyright: (C) 1997 by Gran Gustafsson $
*
\************************************************************************/

/* Type of widget links */
typedef struct GtWList
{
	GtSLink lnk;
	GtWidget *w;
	sbool nowin;
} GtWList;

class GtManager : public GtWidget
{
public:
		/* Standard */
	GtManager(void);
	void Destroy(void);
	sbool Set(GtTag *tgs);
	char *GetClass(void) { return("GtManager"); }
	sbool IsSubClassOf(char *cn);
		/* Window management */
	void Map(sbool map);
	sbool Build(void);
	void Refresh(void);
		/* Events */
	int Handle(XEvent *xe);
		/* Instans checks */
	virtual sbool IsManager(void) { return(FALSE); }
		/* Child managment */
	void PositionChild(GtWidget *o,ulong p);
	virtual sbool AddChild(GtWidget *o,ulong p);
	virtual void RemChild(GtWidget *o);
	virtual sbool SetLInfo(GtWidget *o,GtTag *tgs)
		{ o=o; tgs=tgs; return(FALSE); }
	virtual void GetLInfo(GtWidget *o,GtTag *tgs)
		{ o=o; tgs=tgs; }
	sbool NamedSet(char *n,GtTag *tgs);
	sbool NamedSetV(char *n,ulong tag,...);
		/* Child requests */
	virtual sbool MapReq(GtWidget *o,sbool map)
		{ o=o; map=map; flags|=GTWF_CHG; return(TRUE); }
	virtual void MoveSizeReq(GtWidget *o,word xp,word yp,word xs,word ys);
		/* Layout */
	virtual void Relayout(void) { }
		/* Instance checks */
	GtWidget *Find(char *n);
		/* Values */
	void SetEMask(ulong em);
	sbool SetMinMaxSize(word xs,word ys,word mxs,word mys);
	GtWList *GetManaged(void) { return((GtWList *)GtSFirst(&man)); }
	GtWList *GetUnManaged(void) { return((GtWList *)GtSFirst(&unman)); }
		/* Color management */
	void RemapColors(uword msk,ulong bg,ulong fg,
									ulong lt,ulong dk,ulong fl,ulong ds,GtColormap *cmap);
		/* Internal methods */
	void SetPosSize(word xp,word yp,word xs,word ys);
protected:
		/* Internal methods */
	virtual void Layout(void) { }
	virtual GtWList *MakeWList(GtWidget *o,int sz);
protected:
		/* Instance variables */
	GtSLink unman,man;
	int maxchild,nrchild;
	sbool haswless;
};

extern GtManager *GtMkManager(char *n,GtManager *p,GtTag *tgs);
extern GtManager *GtMkManager(char *n,GtManager *p,ulong tag,...);

#endif /* INC_GTMANAGER_H */
